;============================================================
;
;============================================================

;---

!y_speed_lo     = $B0
!y_speed_hi     = $80

;-

!sfx    = $08
!bank   = $1DFC|!Base2

;-

tilemap:
        db $28,$28,$28,$28
        db $4C,$4C,$4C,$4C
        db $83,$83,$6F,$6F

;---

print "INIT ",pc
        LDA #$02
        STA !1540,x
        LDA !D8,x
        CLC
        ADC #$08
        STA !D8,x
        LDA !14D4,x
        ADC #$00
        STA !14D4,x
        RTL

print "MAIN ",pc
        PHB
        PHK
        PLB
        JSR lg_spring
        PLB
        RTL

;---

lg_spring:
        LDA !14C8,x
        EOR #$08
        ORA $9D
        BEQ +
        JMP .draw_sprite

+       
        LDA !E4,x
        CLC
        ADC #$08
        STA !E4,x
        LDA !14E0,x
        ADC #$00
        STA !14E0,x
        LDA !D8,x
        CLC
        ADC #$08
        STA !D8,x
        LDA !14D4,x
        ADC #$00
        STA !14D4,x
        JSR handle_line_guide
        LDA !D8,x
        SEC
        SBC #$08
        STA !D8,x
        LDA !14D4,x
        SBC #$00
        STA !14D4,x
        LDA !E4,x
        SEC
        SBC #$08
        STA !E4,x
        LDA !14E0,x
        SBC #$00
        STA !14E0,x
        LDA !15AC,x
        BEQ .not_in_spring
        LSR
        TAY
        LDA $187A|!Base2
        CMP #$01
        LDA mario_y_offset,y
        BCC +
        ADC #$11
+       STA $00

        LDA frame,y
        STA !1602,x
        LDA !D8,x
        SEC
        SBC $00
        STA $96
        LDA !14D4,x
        SBC #$00
        STA $97
        STZ $72
        STZ $7B
        LDA #$02
        STA $1471|!Base2
        LDA !15AC,x
        CMP #$07
        BCS .no_bounce
        STZ $1471|!Base2
        LDY #!y_speed_lo
        LDA $17
        BPL +
        LDA #$01
        STA $140D|!Base2
        BRA .bounce_high
+       LDA $15
        BPL +
.bounce_high
        LDA #$0B
        STA $72
        LDY #$80
        STY $1406|!Base2
        if !y_speed_hi != $80
                LDY #!y_speed_hi
        endif
+       STY $7D
        LDA #!sfx
        STA !bank

.no_bounce
        BRA .draw_sprite

.not_in_spring
        JSL $01A7DC|!BankB
        BCC .draw_sprite
        STZ !15AC,x
        LDA !D8,x
        SEC
        SBC $96
        CLC
        ADC #$04
        CMP #$14
        BCC .not_below
        BPL .check_if_interact
        LDA $7D
        BPL .draw_sprite
        STZ $7D
        BRA .draw_sprite
.not_below
        JSR solid_sides
        BRA .draw_sprite

.check_if_interact
        LDA $7D
        BMI .draw_sprite
        LDA #$11
        STA !15AC,x

.draw_sprite
        LDY !1602,x
        LDA extra_y_disp,y
        JSR draw_sprite
        RTS

frame:
        db $00,$01,$02,$02,$02,$01,$01,$00,$00
mario_y_offset:
        db $1E,$1B,$18,$18,$18,$1A,$1C,$1D,$1E
extra_y_disp:
        db $00,$02,$00

;---

solid_sides:
        STZ $7B
        %SubHorzPos()
        TYA
        ASL
        TAY
        REP #$21
        LDA $94
        ADC x_offset,y
        STA $94
        SEP #$20
return:
        RTS

x_offset:
        dw $0001,$FFFF

;---

if !EXLEVEL
        !layer_lookup   = $0BF6|!Base2                   ;   256 bytes of free RAM. Must be on shadow RAM.
        !l1_lookup_lo   = !layer_lookup+96+96            ;   32 bytes
        !l2_lookup_lo   = !layer_lookup+96+96+16         ;   16 bytes (shared)
        !l1_lookup_hi   = !layer_lookup+96+96+32         ;   32 bytes
        !l2_lookup_hi   = !layer_lookup+96+96+32+16      ;   16 bytes (shared)
endif

;-

handle_line_guide:
        LDA !1540,x
        BNE run_state
        LDA $9D
        BNE return
run_state:
        LDA !C2,x
        JSL $0086DF|!BankB

        dw state_00
        dw state_01
        dw state_02

;-

lg_x_offset_lo:
        db $FC,$04,$FC,$04
lg_x_offset_hi:
        db $FF,$00,$FF,$00
lg_y_offset_lo:
        db $FC,$FC,$04,$04
lg_y_offset_hi:
        db $FF,$FF,$00,$00
lg_behavior_tbl_1:
        db $15,$15,$15,$15,$0C,$10,$10,$10
        db $10,$0C,$0C,$10,$10,$10,$10,$0C
        db $15,$15,$10,$10,$10,$10,$10,$10
        db $10,$10,$10,$10,$10,$10,$15,$15
lg_behavior_tbl_2:
        db $00,$00,$00,$00,$00,$00,$01,$02
        db $00,$00,$00,$00,$02,$01,$00,$00
        db $00,$00,$01,$02,$01,$02,$00,$00
        db $00,$00,$02,$02,$00,$00,$00,$00
lg_speed_tbl_y:
        db $00,$10,$00,$F0,$F4,$FC,$F0,$10
        db $04,$0C,$0C,$00,$10,$F0,$FC,$F4
        db $F0,$10,$F0,$10,$F0,$10,$F8,$F8
        db $08,$08,$10,$10,$00,$00,$F0,$10
        db $10,$00,$F0,$F0,$0C,$04,$10,$F0
        db $00,$F4,$F4,$FC,$F0,$10,$00,$0C
        db $10,$F0,$10,$00,$10,$F0,$08,$08
        db $F8,$F8,$F0,$F0,$00,$00,$10,$F0
lg_speed_tbl_x:
        db $10,$00,$10,$00,$0C,$10,$04,$00
        db $10,$0C,$0C,$10,$04,$00,$10,$0C
        db $10,$10,$08,$08,$08,$08,$10,$10
        db $10,$10,$00,$00,$10,$10,$10,$10
        db $00,$F0,$00,$F0,$F4,$F0,$00,$FC
        db $F0,$F4,$F4,$F0,$00,$FC,$F0,$F4
        db $F0,$F0,$F8,$F8,$F8,$F8,$F0,$F0
        db $F0,$F0,$00,$00,$F0,$F0,$F0,$F0

;-

state_00:
        LDY #$03
tile_check_loop:
        STY $1695|!Base2

        LDA !E4,x
        CLC
        ADC lg_x_offset_lo,y
        STA $02
        LDA !14E0,x
        ADC lg_x_offset_hi,y
        STA $03
        LDA !D8,x
        CLC
        ADC lg_y_offset_lo,y
        STA $00
        LDA !14D4,x
        ADC lg_y_offset_hi,y
        STA $01

        LDA !1540,x
        BNE .go_setup_position

        LDA $00
        AND #$F0
        STA $04
        LDA !D8,x
        AND #$F0
        CMP $04
        BNE .go_setup_position
        LDA $02
        AND #$F0
        STA $05
        LDA !E4,x
        AND #$F0
        CMP $05
        BEQ check_if_loop

.go_setup_position
        JSR setup_position
        BNE alt_index

        LDA $1693|!Base2
        CMP #$94
        BEQ .check_on_off
        CMP #$95
        BNE .continue

        LDA $14AF|!Base2
        BEQ check_if_loop
        BNE .continue
.check_on_off
        LDA $14AF|!Base2
        BNE check_if_loop
.continue
        LDA $1693|!Base2
        CMP #$76
        BCC check_if_loop
        CMP #$9A
        BCC is_line_guide

check_if_loop:
        LDY $1695|!Base2
        DEY
        BPL tile_check_loop

        LDA !C2,x
        CMP #$02
        BEQ .return
        LDA #$02
        STA !C2,x

        LDY !160E,x
        LDA !157C,x
        BEQ +
        TYA
        CLC
        ADC #$20
        TAY
+       LDA lg_speed_tbl_y,y;
        BPL $01
        ASL
        PHY
        ASL
        STA !AA,x
        PLY
        LDA lg_speed_tbl_x,y
        ASL
        STA !B6,x
        LDA #$10
        STA !1540,x
.return
        RTS

is_line_guide:
        PHA
        SBC #$75
        TAY
        PLA
        CMP #$96
        BCC no_alt_index
alt_index:
        LDY !160E,x
        BRA skip_position_change
no_alt_index:
        LDA !D8,x
        STA $08
        LDA !14D4,x
        STA $09
        LDA !E4,x
        STA $0A
        LDA !14E0,x
        STA $0B
        LDA $00
        STA !D8,x
        LDA $01
        STA !14D4,x
        LDA $02
        STA !E4,x
        LDA $03
        STA !14E0,x

skip_position_change:
        PEA.w ($07)|(skip_position_change>>16<<8)
        PLB
        LDA $FBF3,y
        STA !151C,x
        LDA $FC13,y
        STA !1528,x
        PLB
        LDA lg_behavior_tbl_1,y
        STA !1570,x
        STZ !1534,x
        TYA
        STA !160E,x
        LDA !1540,x
        BNE set_state_01
        STZ !157C,x
        LDA lg_behavior_tbl_2,y
        BEQ more_pos_setups
        TAY
        LDA !D8,x
        CPY #$01
        BNE +
        EOR #$0F
+       BRA no_load_x

more_pos_setups:
        LDA !E4,x
no_load_x:
        AND #$0F
        CMP #$0A
        BCC .not_left
        LDA !C2,x
        CMP #$02
        BEQ .not_left
        INC !157C,x
.not_left
        LDA !D8,x
        STA $0C
        LDA !E4,x
        STA $0D
        JSR state_01
        LDA $0C
        SEC
        SBC !D8,x
        CLC
        ADC #$08
        CMP #$10
        BCS restore_position
        LDA $0D
        SEC
        SBC !E4,x
        CLC
        ADC #$08
        CMP #$10
        BCS restore_position
set_state_01:
        LDA #$01
        STA !C2,x
        RTS

restore_position:
        LDA $08
        STA !D8,x
        LDA $09
        STA !14D4,x
        LDA $0A
        STA !E4,x
        LDA $0B
        STA !14E0,x
        JMP check_if_loop

setup_position:
        LDA $00
        AND #$F0
        STA $06
        LDA $02
        LSR #4
        PHA
        ORA $06
        PHA
        LDA $5B
        LSR
        BCC .horizontal

        PLA
        LDX $01
        CLC
        ADC $00BA80|!BankB
        STA $05
        LDA $00BABC|!BankB
        ADC $03
        STA $06
        BRA .get_map16

.horizontal
        PLA
        LDX $03
        CLC
        if !EXLEVEL
                ADC !l1_lookup_lo,x
        else
                ADC $00BA60|!BankB,x
        endif
        STA $05
        if !EXLEVEL
                LDA !l1_lookup_hi,x
        else
                LDA $00BA9C|!BankB,x
        endif
        ADC $01
        STA $06

.get_map16
        if !SA1
                LDA #$40
        else
                LDA #$7E
        endif
        STA $07
        LDX $15E9|!Base2
        LDA [$05]
        STA $1693|!Base2
        INC $07
        LDA [$05]
        PLY
        STY $05
        PHA
        LDA $05
        AND #$07
        TAY
        PLA
        AND bit_mask,y
        RTS

bit_mask:
        db $80,$40,$20,$10,$08,$04,$02,$01

;-

state_01:
        LDA $9D
        BNE .return
        LDA !157C,x
        BNE .facing_left
        LDY !1534,x
        JSR move_sprite
        INC !1534,x
        LDA !187B,x
        BEQ .no_frame_check
        LDA $13
        LSR
        BCC .no_frame_check
        INC !1534,x
.no_frame_check
        LDA !1534,x
        CMP !1570,x
        BCC .return
        STZ !C2,x
.return
        RTS
.facing_left
        LDY !1570,x
        DEY
        JSR move_sprite
        DEC !1570,x
        BEQ .set_state_00
        LDA !187B,x
        BEQ .return
        LDA $13
        LSR
        BCC .return
        DEC !1570,x
        BNE .return
.set_state_00
        STZ !C2,x
        RTS

move_sprite:
        PEA.w ($07)|(move_sprite>>16<<8)
        PLB
        LDA !151C,x
        STA $04
        LDA !1528,x
        STA $05

        LDA ($04),y
        AND #$0F
        STA $06
        LDA ($04),y
        PLB
        LSR #4
        STA $07

        LDA !D8,x
        AND #$F0
        CLC
        ADC $07
        STA !D8,x
        LDA !E4,x
        AND #$F0
        CLC
        ADC $06
        STA !E4,x
        RTS

;-

state_02:
        LDA $9D
        BNE .return
        JSL $01802A|!BankB
        LDA !1540,x
        BNE .return
        LDA !AA,x
        CMP #$20
        BMI .return
        JMP state_00
.return
        RTS

;---

x_disp:
        db $00,$08,$00,$08
y_disp:
        db $00,$00,$08,$08
flip:
        db $00,$40,$80,$C0

draw_sprite:
        STA $0F
        %GetDrawInfo()
        LDA $0F
        CLC
        ADC $01
        STA $01
        LDA !1602,x
        ASL #2
        STA $02
        LDA !15F6,x
        ORA $64
        STA $03

        LDX #$03
-       LDA $00
        CLC
        ADC x_disp,x
        STA $0300|!Base2,y
        LDA $01
        CLC
        ADC y_disp,x
        STA $0301|!Base2,y

        PHX
        TXA
        CLC
        ADC $02
        TAX
        LDA tilemap,x
        STA $0302|!Base2,y
        PLX
        LDA flip,x
        ORA $03
        STA $0303|!Base2,y

        INY #4
        DEX
        BPL -

        LDX $15E9|!Base2
        LDA #$03
        LDY #$00
        JSL $01B7B3|!BankB
        RTS

